#!/bin/bash     
path=.

if [ $# -eq 1 ]; then
    file=$1
    echo $file
fi
orig=`pwd`
srate=`echo $file | awk -F'_' '{print $4/10.0}' | bc`
erate=`echo $file | awk -F'_' '{print $6/10.0}' | bc`
delta=`echo $file | awk -F'_' '{print $8/10.0}' | bc`
plen=`echo $file | awk -F '_' '{print $2}'`
idle=`echo $file | awk -F '_' '{print $10}'`
repeat=`echo $file | awk -F '[_.]' '{print $14}'`
sfreq=`echo $file | awk -F '[_.]' '{print $16}'`
scnt=`echo $file | awk -F '[_.]' '{print $18}'`

echo arguments: $crate $srate $erate $delta $plen $idle $repeat $sfreq $scnt $p $q
python process.py -a $file -l $plen -n 20 -i $idle -f $srate -e $erate -d $delta -r $repeat -s $scnt -g $sfreq

cross_len=792
cross_rate=(1)
probe_len=792
cut=5
linear_err=2

processed_file=$file.processed

python calc_q_delay.py -a $processed_file -l $plen -n 20 -i $idle -f $srate -e $erate -d $delta -r $repeat -s $scnt -g $sfreq

mean_file=$file.processed.stats.mean
#cross_idx=$file.cross_idx
#timeseries=$orig/cross_random/cross_mode_2_rate_${crate}_q_${q}_p_${p}.tmp.fixed.100.timeseries

python graph.py $mean_file $cut $linear_err
